﻿package
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Matrix;
    import flash.display.GradientType;
	import flash.display.*;
	public class GraphicInterface extends Sprite
	{
		private var particles:Array;
		private var particleMC:Sprite;
		private var c1:Controller;
		private var c2:Controller;
		private var c3:Controller;
		//public var frameRate:Number;
		//var myShape:Shape = new Shape();
        //var gradientBoxMatrix:Matrix = new Matrix();
		public function GraphicInterface()
		{
			addEventListener(Event.ADDED_TO_STAGE,added_handler);	
		}
		public function added_handler(e:Event):void
		{
			particleMC = new Sprite();
			particles = new Array();
			addChild(particleMC);
			/*c1= new Controller(20);
			c1.x=25;
			c1.y=25;
			addChild(c1);*/
			c2= new Controller(20);
			c2.x=25;
			c2.y=25;
			addChild(c2);
			c3= new Controller(20);
			c3.x=70;
			c3.y=25;
			addChild(c3);
			addEventListener(Event.ENTER_FRAME,onEnterFrame);
		}
		private function onEnterFrame(e:Event):void
		{
			var spreadMethod:String = SpreadMethod.REPEAT;
			var fillType:String = GradientType.LINEAR;
			var colors:Array = [0xFF0000+(c3.controller_value()/10000), 0x0000FF+(c3.controller_value()/10000)];
			var alphas:Array = [1, 1];
     		var ratios:Array = [0x00, 0xFF];
     		var matr:Matrix = new Matrix();
			matr.createGradientBox(stage.stageWidth-mouseX,stage.stageHeight-mouseY, Math.PI / 40, 0, 0);
			createParticle();
			particleMC.graphics.clear();
			for(var i:int=particles.length-1;i>=0;i--) {
				particles[i].x += particles[i].dx;
				particles[i].y += particles[i].dy;
				var nbr:uint =  255 << 16 | Math.round(Math.abs(180-c2.controller_value())*255/360) << 8 | Math.round(Math.abs(180-c2.controller_value())*255/360);
				//particleMC.graphics.beginFill(nbr,0.2/*,(Math.round(Math.abs(180-c3.controller_value())*255/360*10) << 1 | Math.round(Math.abs(180-c3.controller_value())*255/360))/1000*/);
				particleMC.graphics.beginGradientFill(fillType, colors, alphas, ratios, matr, spreadMethod);
				//particleMC.graphics.drawCircle(particles[i].x,particles[i].y,(c1.controller_value()/10+1));
				particleMC.graphics.lineTo((particles[i].x+300)/**(c2.controller_value()/10+1)*/,(particles[i].y+300)/**(c3.controller_value()/10+1)*//*,(c1.controller_value()/10+1)*/);
				particleMC.graphics.lineStyle((c2.controller_value()));
				particleMC.graphics.endFill();
				if (particles[i].life-- <= 0) {
					particles[i].dx = 0;
				    particles[i].dy = 0;
					particleMC.removeChild(particles[i]);
					particles.splice(i,1);
				}
			}
		}
		//ADAPTATION D'UNE FONCTION DE CEM DU 26_08_09
		private function createParticle():void 
		 {
			var p:MovieClip = new MovieClip();
			p.x = stage.stageWidth/2+(1-Math.random()*2000);
			p.y = stage.stageHeight/2+(1-Math.random()*2000);
			p.life = (c2.controller_value())+100;
			p.dx = Math.random()*9-3;
			if (p.y >= stage.stageHeight/2){
			p.dy = Math.random()*4;
				}else if (p.y <=stage.stageHeight/2){
			p.dy = Math.random()*2-4;
					}
			particleMC.addChild(p);
			particles.push(p);
		}
	}
}
import flash.display.Sprite;
import flash.events.MouseEvent;
import flash.events.EventDispatcher;
import flash.events.Event;
class Controller extends Sprite{
	private var line:Sprite = new Sprite();
	public static var dispatcher:EventDispatcher;
	public function Controller(size:Number){
		dispatcher = new EventDispatcher();
		graphics.beginFill(0xffffff,1);
		graphics.lineStyle(1,0x000000,1);
		graphics.drawCircle(0,0,size);
		graphics.endFill();
		line.graphics.beginFill(0x000000,1);
		line.graphics.drawRect(0,0,size,1);
		line.graphics.endFill();
		addChild(line);
		addEventListener(MouseEvent.MOUSE_DOWN,down_handler);
	}
	private function down_handler(e:MouseEvent):void
	{
		addEventListener(MouseEvent.MOUSE_MOVE,move_handler);
		stage.addEventListener(MouseEvent.MOUSE_UP,up_handler);
	}
		private function move_handler(e:MouseEvent):void
	{
		var angle:Number = Math.atan(Math.round(e.localY)/Math.round(e.localX))*180/Math.PI;
		if(e.localX<0){
			angle+=180;
		}
		e.currentTarget.line.rotation=angle-15;
	}
	private function up_handler(e:MouseEvent):void
	{
		removeEventListener(MouseEvent.MOUSE_MOVE,move_handler);
	}
	public function controller_value():Number
	{
		return line.rotation;
	}
}
		//frameRate(10);
/*
package {
    import flash.display.Sprite;
    import flash.display.Shape;
    import flash.geom.Matrix; 
    import flash.display.GradientType;
    
    public class Graphics_lineGradientStyleExample extends Sprite
    {
        public function Graphics_lineGradientStyleExample()
        {
            var myShape:Shape = new Shape();
            var gradientBoxMatrix:Matrix = new Matrix();
  
            gradientBoxMatrix.createGradientBox(200, 40, 0, 0, 0);  
            
            myShape.graphics.lineStyle(5);
  
            myShape.graphics.lineGradientStyle(GradientType.LINEAR, [0xFF0000,
            0x00FF00, 0x0000FF], [1, 1, 1], [0, 128, 255], gradientBoxMatrix);
            
            myShape.graphics.drawRect(0, 0, 200, 40);
            myShape.graphics.drawCircle(100, 120, 50);  
             
            this.addChild(myShape);
    
        }
}
}
*/